      subroutine init_processes
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"
      include "pwhg_flg.h"
      include "pwhg_par.h"
      include "pwhg_st.h"
      include "coupl.inc"

      integer i
      real * 8 tmp
      real * 8 powheginput
      external powheginput

c     The following should be on by default ...
      if(powheginput("#evenmaxrat").ne.0) flg_evenmaxrat = .true.

c by default include negative weights. Allow for
c explicit request not to include them
      if(powheginput("#withnegweights").eq.0) then
         flg_withnegweights = .false.
      else
         flg_withnegweights = .true.
      endif

      par_diexp=powheginput("#par_diexp")
      if(par_diexp.lt.0) par_diexp=2d0
      par_dijexp=powheginput("#par_dijexp")
      if(par_dijexp.lt.0) par_dijexp=2d0
      par_2gsupp=powheginput("#par_2gsupp")
      if(par_2gsupp.lt.0) par_2gsupp=2d0

      flg_withdamp=.true.
      flg_bornzerodamp=.true.

      call init_processes_born
      call init_processes_real
      call init_couplings
      if (mdl_mt.eq.0d0) then
         st_nlight=6
      elseif(mdl_mb.eq.0d0) then
         st_nlight=5
      else
         st_nlight=4
      endif
      do i=3,nlegreal
         if (abs(flst_real(i,1)).le.st_nlight) then
            flst_lightpart=i
            exit
         endif
      enddo
 
      return
      end
 
 
 
      subroutine init_processes_born
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"
      integer iun,iproc,id,itmp

      call newunit(iun)
      open(unit=iun,file='SubProcesses/proc_label', status='old')
      do iproc=1,maxprocborn
         read(iun,*) lproc, itmp, (flst_born(iproc,id), id=1,nlegborn)
      enddo
      close(iun)
      
      flst_nborn=maxprocborn

      end
 
 
 
      subroutine init_processes_real
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"

      
      integer iun,iproc,id,itmp

      call newunit(iun)
      open(unit=iun,file='SubProcesses/proc_label_real', status='old')
      do iproc=1,maxprocreal
         read(iun,*) lproc, itmp, (flst_real(iproc,id), id=1,nlegreal)
      enddo
      close(iun)
      
      flst_nreal=maxprocreal
 
      return
      end
 
