      subroutine sborn_cl_%(metag)s(p1,wgtmunu,wgt)
c  
%(info_lines)s
c
c returns amplitude squared summed/avg over colors
c and helicities
c for the point in phase space p1(0:3,nexternal-1)
c  
%(process_lines)s
c
      implicit none
C  
C CONSTANTS
C  
      include "nexternal.inc"
C  
C ARGUMENTS 
C  
      REAL*8 P1(0:3,NEXTERNAL-1)
      double precision wgt(0:nexternal-1), wgtmunu(0:3,0:3,nexternal-1)

      double complex wgt1(2),wm(8),wp(8),wms(8),wps(8),cwgtmunu(0:3,0:3)
      integer i,j,ij

%(ij_lines)s
%(born_pdg_lines)s
      integer glu_ij
      common/to_glu_ij/glu_ij

      wgt(0:nexternal-1)=0d0
 
      do ij = 1, n_ij
        glu_ij = ij_values(ij)
 
      wgt1(1)=(0d0,0d0)
      wgt1(2)=(0d0,0d0)
      wgt(0) = 0d0

      if (bpdg(glu_ij).eq.21) then
         call VXXXXX(p1(0,glu_ij),0d0, 1,-1,Wp)
         call VXXXXX(p1(0,glu_ij),0d0,-1,-1,Wm)
         call VXXXXX(p1(0,glu_ij),0d0, 1, 1,Wps)
         call VXXXXX(p1(0,glu_ij),0d0,-1, 1,Wms)
      else
         wm(1:8) = 0d0
         wp(1:8) = 0d0
         wms(1:8)= 0d0
         wps(1:8)= 0d0
      endif

      call sborn_%(metag)s(p1, wgt1)
      wgt(0) = dble(wgt1(1))
 
      wgt(glu_ij)=wgt(0)
      do i=0,3
         do j=0,3
            if (glu_ij.le.nincoming) then
C Remember, now the HELAS/ALOHA convention for wavefunctions has changed. The first four components are the momentum, followed by the wavefunction 
               cwgtmunu(i,j)= dble(wgt1(1))*wms(i+5)*wm(j+5)+dimag(wgt1(1))*wps(i+5)*wp(j+5)+wgt1(2)*wps(i+5)*wm(j+5)+dconjg(wgt1(2))*wms(i+5)*wp(j+5)
            else
               cwgtmunu(i,j)= dble(wgt1(1))*wm(i+5)*wms(j+5)+dimag(wgt1(1))*wp(i+5)*wps(j+5)+wgt1(2)*wp(i+5)*wms(j+5)+dconjg(wgt1(2))*wm(i+5)*wps(j+5)
            endif
C            if (dble(cwgtmunu(i,j)).ne.0d0) then
C              if(dimag(cwgtmunu(i,j))/dble(cwgtmunu(i,j)).gt.1d-15) then
C                 write (*,*) "ERROR in sborn_cl_%(metag)s: Bmunu is complex"
C                 stop
C               endif
C            endif
            wgtmunu(i,j,glu_ij)=dble(cwgtmunu(i,j))
         enddo
      enddo
 
      enddo 

      return
      end






      subroutine sborn_%(metag)s(p1,ans)
c  
%(info_lines)s
c
c returns amplitude squared summed/avg over colors
c and helicities
c for the point in phase space p1(0:3,nexternal-1)
c  
%(process_lines)s
c
      implicit none
C  
C CONSTANTS
C  
      include "nexternal.inc"
      include "born_nhel_%(metag)s.inc"
      INTEGER     NCOMB
      PARAMETER ( NCOMB=  %(ncomb)d )
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*%(nconfs)d)
      INTEGER NGRAPHS
      PARAMETER (NGRAPHS=   %(ngraphs)d)
C  
C ARGUMENTS 
C  
      REAL*8 P1(0:3,NEXTERNAL-1)
      COMPLEX*16 ANS(2)
C  
C LOCAL VARIABLES 
C  
      INTEGER IHEL,IDEN,i,j,jj
      REAL*8 BORN_%(metag)s,borns(2)
      COMPLEX*16 BORNTILDE
      integer nextm1
      parameter (nextm1=nexternal-1)
      INTEGER NTRY(nextm1)
      DATA NTRY /nextm1*0/
      INTEGER NHEL(NEXTERNAL-1,NCOMB)
%(helicity_lines)s
%(den_factor_line)s
C  
C GLOBAL VARIABLES
C  
      include "maxamps_B.inc"
      Double Precision amp2(maxgraphs), jamp2(0:maxamps)
      common/to_amps_%(metag)s/  amp2,       jamp2
      DATA jamp2(0) /   %(ncolor)d/          
      LOGICAL GOODHEL(NCOMB,nexternal-1)
      common /c_goodhel_%(metag)s/goodhel
      double complex saveamp(ngraphs,max_bhel)
      common/to_saveamp_%(metag)s/saveamp
      double precision savemom(nexternal-1,2)
      common/to_savemom/savemom
      double precision hel_fac
      integer get_hel,skip(nexternal-1)
      common/cBorn/hel_fac,get_hel,skip
      logical calculatedBorn
      common/ccalculatedBorn/calculatedBorn
      double precision       wgt_ME_born,wgt_ME_real
      common /c_wgt_ME_tree/ wgt_ME_born,wgt_ME_real
      logical cond_ij
      integer glu_ij
      common/to_glu_ij/glu_ij
C ----------
C BEGIN CODE
C ----------
      NTRY(glu_ij)=NTRY(glu_ij)+1
      if (NTRY(glu_ij).lt.2) then
        if (glu_ij.eq.0) then
      	  skip(glu_ij)=0
       else
         skip(glu_ij)=1			 
         do while(nhel(glu_ij ,skip(glu_ij)).ne.-NHEL(GLU_IJ ,1))
            skip(glu_ij)=skip(glu_ij)+1
         enddo
         skip(glu_ij)=skip(glu_ij)-1
       endif
      endif
      DO JJ=1,NGRAPHS
          amp2(jj)=0d0
      ENDDO
      DO JJ=1,int(jamp2(0))
          jamp2(jj)=0d0
      ENDDO
      if (calculatedBorn) then
         do j=1,nexternal-1
            if (savemom(j,1).ne.p1(0,j) .or. savemom(j,2).ne.p1(3,j)) then
               calculatedBorn=.false.
               write (*,*) "momenta not the same in Born"
	       stop
            endif
         enddo
      endif
      if (.not.calculatedBorn) then
         do j=1,nexternal-1
            savemom(j,1)=p1(0,j)
            savemom(j,2)=p1(3,j)
         enddo
         do j=1,max_bhel
            do jj=1,ngraphs
               saveamp(jj,j)=(0d0,0d0)
            enddo
         enddo
      endif
      ANS(1) = 0D0
      ANS(2) = 0D0
      hel_fac=1d0
      DO IHEL=1,NCOMB
        ! the following lines are to avoid segfaults when glu_ij=0
        cond_ij=skip(glu_ij).eq.0
        if (.not.cond_ij) cond_ij=cond_ij.or.nhel(glu_ij,ihel).EQ.NHEL(GLU_IJ,1)
        !if (nhel(glu_ij,ihel).EQ.NHEL(GLU_IJ,1).or.skip(glu_ij).eq.0) then
        if (cond_ij) then
          IF ((GOODHEL(IHEL,glu_ij) .OR. GOODHEL(IHEL+SKIP(glu_ij),glu_ij) .OR. NTRY(glu_ij) .LT. 2) ) THEN
            ANS(1)=ANS(1)+BORN_%(metag)s(P1,NHEL(1,IHEL),IHEL,BORNTILDE,borns)
            ANS(2)=ANS(2)+BORNTILDE
            if ( borns(1).ne.0d0 .AND. .NOT. GOODHEL(IHEL,glu_ij) ) then
              GOODHEL(IHEL,glu_ij)=.TRUE.
            endif
            if ( borns(2).ne.0d0 .AND. .NOT. GOODHEL(IHEL+SKIP(glu_ij),glu_ij) ) then
              GOODHEL(IHEL+SKIP(glu_ij),glu_ij)=.TRUE.
            endif
	  ENDIF
        ENDIF
      ENDDO
      ANS(1)=ANS(1)/DBLE(IDEN)
      ANS(2)=ANS(2)/DBLE(IDEN)
      wgt_me_born=dble(ans(1))
      calculatedBorn=.true.
      END
       
       
      REAL*8 FUNCTION BORN_%(metag)s(P,NHEL,HELL,BORNTILDE,borns)
C  
%(info_lines)s
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL-1)

%(process_lines)s
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=   %(ngraphs)d,NEIGEN=  1) 
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=%(nwavefuncs)d, NCOLOR=%(ncolor)d) 
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      complex*16 imag1
      parameter (imag1 = (0d0,1d0))
      include "nexternal.inc"
      include "born_nhel_%(metag)s.inc"
      include "coupl.inc"
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL-1),borns(2)
      INTEGER NHEL(NEXTERNAL-1), HELL
      complex*16 borntilde
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J,ihel,back_hel
      INTEGER IC(NEXTERNAL-1),nmo
      parameter (nmo=nexternal-1)
      data ic /nmo*1/
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 ZTEMP, AMP(NGRAPHS), JAMP(NCOLOR), W(%(wavefunctionsize)d,NWAVEFUNCS), jamph(2, ncolor)
C  
C GLOBAL VARIABLES
C  
      Double Precision amp2(ngraphs), jamp2(0:ncolor)
      common/to_amps_%(metag)s/  amp2,       jamp2
      double complex saveamp(ngraphs,max_bhel)
      common/to_saveamp_%(metag)s/saveamp
      double precision hel_fac
      integer get_hel,skip(%(nconfs)d)
      common/cBorn/hel_fac,get_hel,skip
      logical calculatedBorn
      common/ccalculatedBorn/calculatedBorn
      integer step_hel
      logical cond_ij
      integer glu_ij
      common/to_glu_ij/glu_ij
C  
C COLOR DATA
C  
%(color_data_lines)s
C ----------
C BEGIN CODE
C ----------
      BORN_%(metag)s = 0d0
      BORNTILDE = (0d0,0d0)
      back_hel = nhel(glu_ij)
      borns(1) = 0d0
      borns(2) = 0d0
      if (glu_ij.ne.0) then
        back_hel = nhel(glu_ij)
        if (back_hel.ne.0) then
          step_hel=-2*back_hel
        else
          step_hel=1
        endif
      else
        back_hel=0
        step_hel=1
      endif
      DO IHEL=back_hel,-back_hel,step_hel
        if (glu_ij.ne.0) then
          cond_ij=IHEL.EQ.back_hel.OR.NHEL(GLU_IJ).NE.0
        else
          cond_ij=IHEL.EQ.back_hel 
        endif
        IF (cond_ij) THEN
        if (glu_ij.ne.0) then
          if (nhel(glu_ij).ne.0) nhel(glu_ij) = ihel
        endif
        if (.not. calculatedBorn) then
%(helas_calls)s
        do i=1,ngraphs
          if(ihel.eq.back_hel)then
            saveamp(i,hell)=amp(i)
          elseif(ihel.eq.-back_hel)then
            saveamp(i,hell+skip(glu_ij))=amp(i)
          else
            write(*,*) "ERROR #1 in born.f"
            stop
          endif
        enddo
        elseif (calculatedBorn) then
        do i=1,ngraphs
          if(ihel.eq.back_hel)then
            amp(i)=saveamp(i,hell)
          elseif(ihel.eq.-back_hel)then
            amp(i)=saveamp(i,hell+skip(glu_ij))
          else
            write(*,*) "ERROR #1 in born.f"
            stop
          endif
        enddo
        endif
%(jamp_lines)s
        DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
            ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
          ENDDO
          BORNS(2-(1+back_hel*ihel)/2)=BORNS(2-(1+back_hel*ihel)/2)+ZTEMP*DCONJG(JAMP(I))/DENOM(I)   
        ENDDO
        Do I = 1, NGRAPHS
          amp2(i)=amp2(i)+amp(i)*dconjg(amp(i))
        Enddo
        Do I = 1, NCOLOR
          Jamp2(i)=Jamp2(i)+Jamp(i)*dconjg(Jamp(i))
          Jamph(2-(1+back_hel*ihel)/2,i)=Jamp(i)
        Enddo
      endif
      Enddo
      BORN_%(metag)s=BORNS(1)+BORNS(2)
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          ZTEMP = ZTEMP + CF(J,I)*JAMPH(2,J)
        ENDDO
        BORNTILDE = BORNTILDE + ZTEMP*DCONJG(JAMPH(1,I))/DENOM(I)
      ENDDO
      if (glu_ij.ne.0) nhel(glu_ij) = back_hel
      END
       

      BLOCK DATA GOODHELS_%(metag)s
      include 'nexternal.inc'
      integer nextm1
      parameter (nextm1=nexternal-1)   
      INTEGER     NCOMB
      PARAMETER ( NCOMB=  %(ncomb)d )
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*nextm1)
      LOGICAL GOODHEL(NCOMB,nextm1)
      common /c_goodhel_%(metag)s/goodhel
      DATA GOODHEL/THEL*.FALSE./
      end
