      subroutine init_processes
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"
      include "pwhg_flg.h"
      include "pwhg_par.h"
      include "pwhg_st.h"
      include "coupl.inc"

      integer i
      real * 8 tmp
      real * 8 powheginput
      external powheginput

c     The following should be on by default ...
      if(powheginput("#evenmaxrat").ne.0) flg_evenmaxrat = .true.

c by default include negative weights. Allow for
c explicit request not to include them
      if(powheginput("#withnegweights").eq.0) then
         flg_withnegweights = .false.
      else
         flg_withnegweights = .true.
      endif

      par_diexp=powheginput("#par_diexp")
      if(par_diexp.lt.0) par_diexp=2d0
      par_dijexp=powheginput("#par_dijexp")
      if(par_dijexp.lt.0) par_dijexp=2d0
      par_2gsupp=powheginput("#par_2gsupp")
      if(par_2gsupp.lt.0) par_2gsupp=2d0

      flg_withdamp=.true.
      flg_bornzerodamp=.true.

      call init_processes_born
      call init_processes_real
      call init_couplings

      st_nlight = NF ! based on MG5 model

      do i=3,nlegreal
         if (abs(flst_real(i,1)).le.st_nlight) then
            flst_lightpart=i
            exit
         endif
      enddo

      return
      end

      subroutine init_processes_born
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"

      %(flst_born_lines)s

      flst_nborn =  %(flst_nborn)d
      end

      subroutine init_processes_real
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"

      %(flst_real_lines)s

      flst_nreal = %(flst_nreal)d
      end
